<?php
	 /* 
	 Plugin Name: Tu CPT's
	 Plugin URI: https://tuweb.com
	 Description: Plugin para crear CPT's
	 Version: 1.0.0
	 Author: Tu Nombre
	 Author URI: https://tuweb.com
	 License: GPL 2+ 
	 License URI: https://tuweb.com
	 */ 
	// Registrar el CPT
	function cg_cpt_proyectos() {

		$labels = array(
			'name'                  => _x( 'Proyectos', 'cg-cpt-proyectos' ),
			'singular_name'         => _x( 'Proyecto', 'cg-cpt-Proyectos' ),
			'menu_name'             => __( 'Proyectos', 'cg-cpt-Proyectos' ),
			'archives'              => __( 'Todos los Proyectos', 'cg-cpt-Proyectos' ),
			'all_items'             => __( 'Todos los Proyectos', 'cg-cpt-Proyectos' ),
			'add_new_item'          => __( 'Añadir nuevo Proyecto', 'cg-cpt-Proyectos' ),
			'add_new'               => __( 'Añadir Proyecto', 'cg-cpt-Proyectos' ),
			'new_item'              => __( 'Nuevo Proyecto', 'cg-cpt-Proyectos' ),
			'edit_item'             => __( 'Editar Proyecto', 'cg-cpt-Proyectos' ),
			'update_item'           => __( 'Actualizar Proyecto', 'cg-cpt-Proyectos' ),
			'view_item'             => __( 'Ver Proyecto', 'cg-cpt-Proyectos' ),
			'search_items'          => __( 'Buscar Proyecto', 'cg-cpt-Proyectos' ),
			'not_found'             => __( 'No encontrado', 'cg-cpt-Proyectos' ),
			'not_found_in_trash'    => __( 'No se encuentra en la papelera', 'cg-cpt-Proyectos' ),
			'insert_into_item'      => __( 'Insertar', 'cg-cpt-Proyectos' ),
			'uploaded_to_this_item' => __( 'Añadido a este Proyecto', 'cg-cpt-Proyectos' ),
			'items_list'            => __( 'Listado de Proyecto', 'cg-cpt-Proyectos' ),
			'items_list_navigation' => __( 'Navegación por los Proyectos', 'cg-cpt-Proyectos' ),
			'filter_items_list'     => __( 'Lista de Proyectos filtrados', 'cg-cpt-Proyectos' ),
		);

		$args = array(
			'label'                 => __( 'Proyectos', 'cg-cpt-Proyectos' ),
			'description'           => __( 'Los Proyectos disponibles', 'cg-cpt-Proyectos' ),
			'labels'                => $labels,
			'supports'              => array( 'page-attributes', 'title', 'editor', 'excerpt', 'thumbnail', 'custom-fields', 'genesis-cpt-archives-settings', 'genesis-seo', 'genesis-scripts', 'genesis-layouts', 'genesis-rel-author', ),
			'taxonomies'            => array( 'proyectos_category' ),
			'hierarchical'          => true,
			'public'                => true,
			'show_ui'               => true,
			'show_in_menu'          => true,
			'menu_position'         => 10,
			'menu_icon'             => 'dashicons-portfolio',
			'show_in_admin_bar'     => true,
			'show_in_nav_menus'     => true,
	        'show_in_rest'          => true,
			'can_export'            => true,
			'has_archive'           => true,
			'exclude_from_search'   => false,
			'publicly_queryable'    => true,
			'query_var'             => 'cg-cpt-proyectos',
			'rewrite' => array(
				'slug' => __( 'proyectos', 'cg-cpt-proyectos' ),
			),
			'capability_type'       => 'page',
		);
		register_post_type( 'Proyectos', $args );

	}
	add_action( 'init', 'cg_cpt_proyectos', 0 );


	// Registrar una categoría
	function cg_proyectos_category() {

		$labelsCategory = array(
			'name'                       => __( 'Categorías de Proyectos', 'cg-cpt-proyectos' ),
			'singular_name'              => __( 'Categoría del Proyecto', 'Taxonomy Singular Name', 'cg-cpt-proyectos' ),
			'all_items'                  => __( 'Todas las categorías', 'cg-cpt-proyectos' ),
			'new_item_name'              => __( 'Nombre de la nueva categoría', 'cg-cpt-proyectos' ),
			'add_new_item'               => __( 'Añadir categoría', 'cg-cpt-proyectos' ),
			'edit_item'                  => __( 'Editar categoría', 'cg-cpt-proyectos' ),
			'update_item'                => __( 'Actualizar categoría', 'cg-cpt-proyectos' ),
			'view_item'                  => __( 'Ver categoría', 'cg-cpt-proyectos' ),
			'separate_items_with_commas' => __( 'Separar categorías con comas', 'cg-cpt-proyectos' ),
			'add_or_remove_items'        => __( 'Añadir o quitar categorías', 'cg-cpt-proyectos' ),
			'choose_from_most_used'      => __( 'Elige entre las más usadas', 'cg-cpt-proyectos' ),
			'popular_items'              => __( 'Categorías populares', 'cg-cpt-proyectos' ),
			'search_items'               => __( 'Buscar categorías', 'cg-cpt-proyectos' ),
			'not_found'                  => __( 'No encontrada', 'cg-cpt-proyectos' ),
			'no_terms'                   => __( 'No hay categorías', 'cg-cpt-proyectos' ),
			'items_list'                 => __( 'Lista de categorías', 'cg-cpt-proyectos' ),
			'items_list_navigation'      => __( 'Navegación por la lista de categorías', 'cg-cpt-proyectos' ),
		);

		$argsCategory = array(
			'labels'                     => $labelsCategory,
			'hierarchical'               => true,
			'public'                     => true,
			'show_admin_column'          => true,
			'show_in_rest'         		 => true,
			'rewrite'  => array(
				'slug' => __( 'categoria-croyectos', 'cg-cpt-proyectos' ),
			),

		);
		register_taxonomy( 'proyectos_category', array( 'proyectos' ), $argsCategory );
		
	}
	add_action( 'init', 'cg_proyectos_category', 0 );

	// Resetear los enlaces permanetes tras la activación/desactivación del plugin
	register_deactivation_hook( __FILE__, 'flush_rewrite_rules' );
	register_activation_hook( __FILE__, 'cg_cpt_proyectos_rewrite_flush' );

	function cg_cpt_proyectos_rewrite_flush(){
	  cg_cpt_proyectos();
	  flush_rewrite_rules();
	}
?>